:
#
# version 3.0 Sep 25 11:21:02 PDT 1998

umask 022
# This tool suite was written by and is copyrighted by Brad Powell, Matt 
# Archibald, and Dan Farmer 1992, 1993, 1994, 1995, 1996, 1997, 1998 with input 
# from Casper Dik, and Alec Muffett.
#
# The copyright holder disclaims all responsibility or liability with 
# respect to its usage or its effect upon hardware or computer 
# systems, and maintains copyright as set out in the "LICENSE" 
# document which accompanies distribution. 

# setup
# dont change the following unless you want to do some work on the script
IFS=:

TITANHOME=`pwd`
PATH=/usr/ucb:/bin:/usr/bin:/sbin:$TITANHOME/lib
MYNAME=`basename $0`
OS=`uname -r`

# did things work out or not?
action=`sanity_check $MYNAME $1`
if test $? -ne 0 ; then
        exit 1
        fi

#
# suck in some lib functions (t_echo, etc.)
#
. misc_functions.sh

Intro() {

cat << EOF

 This program checks, for system UID's only the contents of search
 path variables for "."  We do so by checking system defaults
 of "." in a path.  At a minimum the following files are checked:

 /.login  /etc/.login  /etc/default/login  /.cshrc  /etc/skel/local.cshrc
 /etc/skel/local.login  /etc/skel/local.profile  /.profile  /etc/profile

 After checking for "." we then chown to root everything in roots path
 this is important so that non-root users can't plant trojans for root
EOF
}

VrfyPath() {

for FILE in /.login /etc/.login /etc/default/login /.cshrc /etc/skel/local.cshrc /etc/skel/local.login /etc/skel/local.profile /.profile /etc/profile
 do
 (grep -i path ${FILE} 2>/dev/null) | egrep -s '(\.\:| \. |\.\)|\./)' 

if [ $? -eq 0 ]; then
  t_echo 0 "       $FILE - Contains . - FAILS CHECK"
 grep -i -s path ${FILE} | egrep '(\.\:| \. |\.\)|\./)'
  case "$1" in
    -V)
    ;;
    -F)
    FixPath -F $FILE
    ;;
    *)
    t_echo 1 "       ERROR ($0) - Someone passed me an arg I can't understand "
    exit 1
    ;;
  esac
else
  t_echo 2 "        $FILE - Clean of . - PASSES CHECK" 
fi

done

}


FixPath() {

# set -x
t_echo 0 "Fixing ${FILE} Now..."
  case "$1" in
        -V)
        ;;
        -F)
	ed - $FILE <<- EOED
	g/ path/s/\.\://g
	g/ path/s/ \. //g
	g/ path/s/\.\///g
	g/ path/s/\.*)/ )/g
	g/ path/s/(*\./( /g
	g/^PATH/s/\.\://g
	g/^PATH/s/ \. //g
	g/^PATH/s/\.\///g
	g/^PATH/s/\.*)/ )/g
	g/^PATH/s/(*\./( /g
	.
	w!
	q!
EOED
        ;;
   esac
# unset -x

t_echo 0  "Fixing all directories in roots path"
# Directories world/group writable and ownership fixes
 
for DIR in $PATH
do
        if test -d $DIR
        then
                chown root $DIR
                if ls -dl $DIR | grep -s "^........w"
                then
                        t_echo 0 "   "  $DIR is writable by world. Fixing
                                chmod o-w .
                else
                        t_echo 2 "   "  $DIR is not writable by world.
                fi
                if ls -dl $DIR | grep -s "^.....w"
                then
                        t_echo 0 "   "  $DIR is writable by group. Fixing
                                chmod g-w .
                else
                        t_echo 2 "   "  $DIR is not writable by group.
                fi
        else
                t_echo 1 "   "  $DIR is not a directory!
        fi
done


}

action=$1
	case ${action} in
	-[Ii]*)
	Intro
	;;
	 -[Ff]*)
	VrfyPath -F
	;;
	-[Vv]*)
	VrfyPath -V
	;;
	*)
        t_echo 1 "        ERROR:Invalid arg $action"
        t_echo 1 "        ERROR:Usage $MYNAME -[ivf] (I)ntro/(V)erify/(F)ix"
        t_echo 1 " "
	;;
	esac

