:
#
# version 3.0 Sep 25 11:21:02 PDT 1998

umask 022

# This tool suite was written by and is copyrighted by Brad Powell, Matt 
# Archibald, and Dan Farmer 1992, 1993, 1994, 1995, 1996, 1997, 1998 with input 
# from Casper Dik, and Alec Muffett.
#
# The copyright holder disclaims all responsibility or liability with  
# respect to its usage or its effect upon hardware or computer 
# systems, and maintains copyright as set out in the "LICENSE"  
# document which accompanies distribution. 
  
TITANHOME=`pwd`
PATH=/usr/ucb:/bin:/usr/bin:/sbin:$TITANHOME/lib
MYNAME=`basename $0`
# did things work out or not?
action=`sanity_check $MYNAME $1`
if test $? -ne 0 ; then
        exit 1
        fi

. misc_functions.sh
 
Intro() {

cat << EOF_INTRO


Check #10 quiet_routed - Move /usr/etc/in.routed to /usr/etc/in.routed.asetorigional
     then build a wrapper starting routed -q. This is done to be compatible
     with the ASET package.

EOF_INTRO

}

Check() {

if [ -f /usr/etc/in.routed.asetoriginal ]
  then
	t_echo 2 "route daemon already configured to be opaque. PASSES CHECK"
else
	t_echo 0 " route daemon is advertising routes: FAILS CHECK"
fi

}

Fix() {
if [ -f /usr/etc/in.routed.asetoriginal ]
  then
        t_echo 2 "route daemon already configured to be opaque. PASSES CHECK"
else
	/bin/mv /usr/etc/in.routed /usr/etc/in.routed.asetoriginal
	if [ $? -ne 0 ]
	then   
	t_echo 1
	t_echo 1 "Could not rename in.routed"
	exit 1
	fi
fi

t_echo 2
echo "#! /bin/sh" > /usr/etc/in.routed
if [ $? -ne 0 ]
	then   
	t_echo 1
	t_echo 1 "Could not create new ${ROUTED} script."
	exit 1
fi
echo "/usr/etc/in.routed.asetoriginal -q \$*" >> /usr/etc/in.routed
/bin/chmod 0755 /usr/etc/in.routed
if [ $? -ne 0 ]
	then
	t_echo 1
	t_echo 1 "Could not chmod new ${ROUTED} script."
	exit 1
	fi

t_echo 0
t_echo 0 " Renamed in.routed to in.routed.asetorigional."
t_echo 0 " Installed new in.routed script."


}

action=$1
case $action in
 -[Ff]*)
Fix
;;
 -[Vv]*)
Check
;;
 -[Ii]*)
Intro
;;
 
*)
        t_echo 1 "        ERROR:Invalid arg $action"
        t_echo 1 "        ERROR:Usage $MYNAME -[ivf] (I)ntro/(V)erify/(F)ix"
 
        t_echo 1 " "
;;
esac

