:
#
# version 3.0 Sep 25 11:21:02 PDT 1998

umask 022

# This tool suite was written by and is copyrighted by Brad Powell, Matt 
# Archibald, and Dan Farmer 1992, 1993, 1994, 1995, 1996, 1997, 1998 with input 
# from Casper Dik, and Alec Muffett.
#
# The copyright holder disclaims all responsibility or liability with  
# respect to its usage or its effect upon hardware or computer 
# systems, and maintains copyright as set out in the "LICENSE"  
# document which accompanies distribution. 
  
TITANHOME=`pwd`
PATH=/usr/ucb:/bin:/usr/bin:/sbin:$TITANHOME/lib
MYNAME=`basename $0`
# did things work out or not?
action=`sanity_check $MYNAME $1`
if test $? -ne 0 ; then
        exit 1
        fi

. misc_functions.sh
 
Intro() {

cat << EOF_INTRO

Check #9 Add secure tftp switch Diskless Workstation Server
EOF_INTRO
}


Check() {
t_echo 2 Check 9a: Checking /etc/inetd.conf for secure Diskless Server tftpd entry

if test -d /tftpboot
then
	t_echo 2 " System directory /tftpboot is set as a Diskless server"
	t_echo 2 " Checking for tftp running"
	else
	t_echo 0 "   No /tftpboot directory. FAILS CHECK"
	fi

	if grep -s "^tftp" /etc/inetd.conf
	then
	if grep -s "in.tftpd -s" /etc/inetd.conf
	then
		t_echo 2 "    Tftp service has been set up as a diskless server"
	else
		t_echo 2 "    Tftp not secure for server. FAILS CHECK"
	fi
fi
}

Fix() {
	if grep -s "^tftp" /etc/inetd.conf
	 then
	mkdir /tftpboot
	chmod 755 /tftpboot
	ed - /etc/inetd.conf <<- !
	g/^tftp/s/\/usr\/etc\/in\.tftpd/\/usr\/etc\/in.tftpd -s \/tftpboot/
	w
	q
	!
	fi

	if grep -s "^#tftp" /etc/inetd.conf
	then
		t_echo 2 "    System is set up to not have tftp running: PASSES CHECK"
	fi

}

action=$1
case $action in
 -[Ff]*)
Fix
;;
 -[Vv]*)
Check
;;
 -[Ii]*)
Intro
;;
 
*)
        t_echo 1 "        ERROR:Invalid arg $action"
        t_echo 1 "        ERROR:Usage $MYNAME -[ivf] (I)ntro/(V)erify/(F)ix"
 
        t_echo 1 " "
;;
esac

