:
#
# version 3.0 Sep 25 11:21:02 PDT 1998
# rev 3.01 Tue Nov  3 17:46:47 PST 1998
#       zen - changed /usr/ucb/echo -n to nawk stuff.

umask 022
# This tool suite was written by and is copyrighted by Brad Powell, Matt 
# Archibald, and Dan Farmer 1992, 1993, 1994, 1995, 1996, 1997, 1998 with input 
# from Casper Dik, and Alec Muffett.
#
# The copyright holder disclaims all responsibility or liability with
# respect to its usage or its effect upon hardware or computer
# systems, and maintains copyright as set out in the "LICENSE"
# document which accompanies distribution.
#

# Attempts to calculate files which Titan will modify in order
# to make backup copies... Note that this does NOT apply to the
# file permission change modules file-own.sh, ziplock.sh.
# Everything backed up is fully qualified from '/'.
#
# Assumes that you have written a module using fully qualified paths
# to commands and then run lib/swapcomms.sh to force utilization of the
# command variables in lib/misc_functions.sh a minimum set of which are
# supplied in misc_functions.sh as follows:
#
# export RM RMF MV MVF LN LNS ED EX SED AWK NAWK GREP GREPS FGREP EGREP
# export TOUCH CHOWN CHMOD CHGRP GREPI EGREPI FGREPS FGREPIS FGREPSI
# export EGREPSI EGREPIS EGREPS 

TITANHOME=`pwd`
PATH=/usr/ucb:/bin:/usr/bin:/sbin:$TITANHOME/lib

#
# Include some meaningful stuff and includes from lib
#
. $TITANHOME/lib/misc_functions.sh
DATE=`/bin/date +%m%d%y%H%M`
export DATE
BACKDIR=$TITANHOME/Backup/$HOST/$DATE
BACKFILE=${TITANHOME}/FBACKUP.tmp
BACKDATA=${TITANHOME}/BACKUPDAT.tmp
SAVELIST=${BACKDIR}/../SaveList.${DATE}

#
# Make a backup dir in $TITANHOME/Backup

if [ -d $BACKDIR ]; then
 echo "Backup dir $BACKDIR - OK"
else
 echo "Creating backup dir in : $BACKDIR"
 /bin/mkdir -p $BACKDIR
fi

#
# Zero out the files we need
#
> ${BACKDATA}
> ${BACKFILE}
> ${SAVELIST}

#
# Genrate a listing of potential victims for backups....
#
echo "Generating listings....."
egrep '(LIST=|FILES=|rm|mv|ln|ed|ex|sed|awk|grep|perl|touch|chmod|chown|chgrp)' ${TITANHOME}/modules/* | sed -e 's/\${[A-Z]*[A-Z]}//g' | sed -e 's/[{,}]//g' | sed -e 's/\$//g' | tr -d '[' | tr -d ']' | tr -d '\`' | tr -d '[<,>,\#,(,)]' | awk -F":" '{print $2}' | grep "[A-z][A-z]" | egrep -v '(\*)' | sort -u >${BACKDATA}


#
# Check for files as opposed to directories. Burn /dev/ip & /dev/null or we hang forever
#
for NAME in `cat ${BACKDATA} | egrep -v '(\*|\/dev\/ip|\/dev\/null)'`
 do
	if [ -z "$NAME" -o -d $NAME ]; then
	 echo "System dir/file passing = $NAME" >/dev/null 2>&-
	else
         if [ -f $NAME -o -r $NAME -o -x $NAME ]; then
           echo $NAME | tr -d ' ' >>${BACKFILE}
         fi
	fi
done

#
# Now take a cleaner list and make dir's, copy files etc....
#
BACKCOUNT=0
nawk 'BEGIN {printf("Calculating and backing up files now...")}' /dev/null

for FILE in `sort -u ${BACKFILE}`
 do
  if [ -z "$FILE" -o -d $FILE ]; then
     echo "System dir/file passing = $FILE"
  else
      if [ -f $FILE -o -r $FILE -o -x $FILE ]; then
	BACKCOUNT=`expr ${BACKCOUNT} + 1`
	nawk 'BEGIN {printf(".")}' /dev/null
 	BASENAME=`basename ${FILE}`
  	AWKNAME=`echo $FILE | awk -F"/" '{for ( i = 1; i < NF; ++i ) printf("/%s",$i) }'`
	DIRNAME=`echo $AWKNAME | sed -e 's/^\///'`
  	/bin/mkdir -p ${BACKDIR}${DIRNAME}
	/bin/cp -p ${FILE} ${BACKDIR}${DIRNAME}
	# /bin/ls -l ${BACKDIR}${DIRNAME}/${BASENAME}
	echo ${FILE} | sed -e 's/^\///g' >>${SAVELIST}
      fi
  fi
done

echo " Done!!"

#
# Cleanup leading '/' in SAVELIST such that we can 
# use cpio, tar etc.. to recover files to original locations
#

#
# Tell me what we did...
#
for CLEAN in ${BACKDATA} ${BACKFILE}
 do
 if [ -r ${CLEAN} ]; then
 /bin/rm -f ${CLEAN}
 echo "..."
 fi
done
echo "Saved off ${BACKCOUNT} files to: ${BACKDIR}"
echo "See details in savelist: ${SAVELIST}"
echo "Restore by running ${TITANHOME}/lib/untit.sh -[g,r]"



# finis
exit 0
