:
#
# version 3.0 Sep 25 11:21:02 PDT 1998
# rev 3.01 Tue Nov  3 17:46:47 PST 1998
#       zen - changed /usr/ucb/echo -n to nawk stuff.

umask 022
# This tool suite was written by and is copyrighted by Brad Powell, Matt 
# Archibald, and Dan Farmer 1992, 1993, 1994, 1995, 1996, 1997, 1998 with input 
# from Casper Dik, and Alec Muffett.
#
# The copyright holder disclaims all responsibility or liability with
# respect to its usage or its effect upon hardware or computer
# systems, and maintains copyright as set out in the "LICENSE"
# document which accompanies distribution.
#

#
# Attempts to calculate files which Titan will modify in order
# to make backup copies... Note that this does NOT apply to the
# file permission change modules file-own.sh, ziplock.sh.
# All files backed up are fully qualifed from '/' for ease of
# recovery
#

# Assumes that you have written a module using fully qualified paths
# to commands and then run lib/swapcomms.sh to force utilization of the
# command variables in lib/misc_functions.sh a minimum set of which are
# supplied in misc_functions.sh as follows:
#
# export RM RMF MV MVF LN LNS ED EX SED AWK NAWK GREP GREPS FGREP EGREP
# export TOUCH CHOWN CHMOD CHGRP GREPI EGREPI FGREPS FGREPIS FGREPSI
# export EGREPSI EGREPIS EGREPS 

TITANHOME=`pwd`
PATH=/usr/ucb:/bin:/usr/bin:/sbin:$TITANHOME/lib

#
# Include some meaningful stuff and includes from lib
#
. $TITANHOME/lib/misc_functions.sh
DATE=`/bin/date +%m%d%y%H%M`
export DATE
REVDIR=$TITANHOME/Backup/$HOST
REVARCHIVES=`ls ${BACKDIR}/*`
REVDATA=${REVDIR}/REVERSE.tmp
SAVELIST=`ls ${REVDIR}/SaveList.*`

#
# Recover from a backup dir in $TITANHOME/Backup

GetRecoverInfo() {

if [ -d $REVDIR ]; then
 echo "Backup dir $REVDIR - OK"
 echo " "
 echo "Available archives: "

 for NAME in ${SAVELIST}
  do
   echo "	`basename $NAME`"
 done

else
 echo "No backup dir in : $REVDIR - Nothing to recover"
 exit 1
fi

}

ReverseTitan() {

 nawk 'BEGIN {printf("Name of savelist: ")}' /dev/null

 read REVLIST
 echo "Set savelist for recover to: $REVLIST"
 if [ -r ${NAME} ]; then
 echo "Dropping all leading '/' from `basename ${NAME}`...."
 /bin/cp -f ${NAME} ${REVDATA}

ed - ${REVDATA} <<EOEF
g/\//s/^///g
.
w!
wq!
EOEF

 echo "Recovering files now....."

 ARCHDIR=`basename ${NAME}` 
 ARCHLOC=`echo ${ARCHDIR} | awk -F"." '{print $2}'`
 echo "Moving Titan files aside to foo.revtitan..."
 for REVFILE in `cat ${NAME} | awk '{print "/"$1}'`
 do
 if [ -r ${REVFILE}.revtitan ]; then
 /bin/mv ${REVFILE} /${REVFILE}.revtitan
 fi
 done
 echo "Done - Restoring saved files from ${SAVELIST}..." 
 
 set -
 cd ${REVDIR}/${ARCHLOC}
 tar cvpf - `ls`|(cd /;tar xvpf - ) 

 echo "Done - Removing Titan files named foo.revtitan..."

 for REVFILE in `cat ${NAME}`
 do
 if [ -r /${REVFILE}.revtitan ]; then
 /bin/rm /${REVFILE} /${REVFILE}.revtitan
 fi
 done
 echo "Done"

 echo "Recovery complete..."
 /bin/rm -f ${REVDATA}
 exit 0
 else
 echo "Nope - Don't see ${NAME} - Try again"
 echo "No backup dir in : $REVDIR - Nothing to recover"
 nawk 'BEGIN {printf("Alternate locations for backups (<dirname>/N): ")}' /dev/null
 read DIRNAME

 case $DIRNAME in
  [nN]) echo "Okay - Exiting";exit 1;;
  *)
  echo "Checking for ${DIRNAME} .... "
  REVDIR=${DIRNAME}
  export REVDIR
  GetRecoverInfo
  ;;
 esac
 fi
}

Usage() {
echo "Usage: $0 -[g,r]
Where: $0 -g shows all available recovery files
Where: $0 -r recovers files from your selected savelist"
}

if [ $# -lt 1 ]; then
 Usage
 exit 1
fi

case $1 in
 -[gG]|[gG])
	GetRecoverInfo
 ;;
 -[rR]|[rR])
	GetRecoverInfo
	ReverseTitan
 ;;
 *)
 	Usage
 ;;
esac

exit 0
