:
#
# version 3.0 Sep 25 11:21:02 PDT 1998

umask 022
# This tool suite was written by and is copyrighted by Brad Powell, Matt 
# Archibald, and Dan Farmer 1992, 1993, 1994, 1995, 1996, 1997, 1998 with input 
# from Casper Dik, and Alec Muffett.
#
# The copyright holder disclaims all responsibility or liability with 
# respect to its usage or its effect upon hardware or computer 
# systems, and maintains copyright as set out in the "LICENSE" 
# document which accompanies distribution. 

#
# setup
TITANHOME=`pwd`
PATH=/usr/ucb:/bin:/usr/bin:/sbin:$TITANHOME/lib
MYNAME=`basename $0`

OS=`uname -r`

# did things work out or not?
action=`sanity_check $MYNAME $1`
if test $? -ne 0 ; then
        exit 1
        fi

#
# suck in some lib functions (t_echo, etc.)
#
. misc_functions.sh

Intro() {

cat << EOF
 This program creates a default UMASK entry for all
 of the boot time run scripts of 022 (forces the rc
 scripts to create files of mode 644)

EOF

}

# Basic lookup and repair functions
#
FixUmask() {
t_echo 0 " Updating init umask file /etc/init.d/umask.sh..."
echo 'umask  022' > /etc/init.d/umask.sh
t_echo 0 " Linking init umask file /etc/init.d/umask.sh..."
  for dir in /etc/rc?.d
   do
   ln -s /etc/init.d/umask.sh $dir/S00umask.sh
   t_echo 0 -n " "
   ls -l $dir/S00umask.sh
  done
t_echo 2 " Done..."
}

CheckUmask() {
UMSK=`grep umask /etc/init.d/umask.sh | awk '{print $2}'`        
  if [ "$UMSK" != "022" ]; then 
  t_echo 2 "        Umask set to $UMSK should be 022.. Repairing"
  FixUmask
  else
  t_echo 2 "        Umask value set to $UMSK.. PASSES CHECK"
  fi
}

action=$1	

	case ${action} in
	-[Ii]*)
	Intro
	;;
	-[Ff]*)
	if [ -f /etc/init.d/umask.sh ]; then
	CheckUmask
	else
 t_echo 1 " No umask file /etc/init.d/umask.sh found"
	FixUmask
	fi
	;;
	-[Vv]*)
	if [ -f /etc/init.d/umask.sh ]; then
	CheckUmask
	else
 t_echo 1 "        No umask file /etc/init.d/umask.sh found"
	fi
	;;
	*)
 t_echo 1 " "
 t_echo 1 "        ERROR:Invalid arg $action"
 t_echo 1 "        ERROR:Usage $MYNAME -[ivf] (I)ntroduction/(V)erify/(F)ix"
 t_echo 1 " "
	;;
	esac	


# End
