:
#
# version 3.0 Sep 25 11:21:02 PDT 1998

umask 022
# This tool suite was written by and is copyrighted by Brad Powell, Matt 
# Archibald, and Dan Farmer 1992, 1993, 1994, 1995, 1996, 1997, 1998 with input 
# from Casper Dik, and Alec Muffett.
#
# The copyright holder disclaims all responsibility or liability with 
# respect to its usage or its effect upon hardware or computer 
# systems, and maintains copyright as set out in the "LICENSE" 
# document which accompanies distribution. 

# setup
TITANHOME=`pwd`
PATH=/usr/ucb:/bin:/usr/bin:/sbin:$TITANHOME/lib
MYNAME=`basename $0`

OS=`uname -r`

# did things work out or not?
action=`sanity_check $MYNAME $1`
if test $? -ne 0 ; then
        exit 1
        fi

#
# suck in some lib functions (t_echo, etc.)
#
. misc_functions.sh

Intro() {

cat << EOF
 This program modifies /etc/rc2.d/S74autofs so that
 automounter does not start at system boot.

EOF

}

FixAutofs() {

 AUTOFS=`grep -s "automount" /etc/rc2.d/S74autofs |\
	grep -v "^#" | awk '{print $1}'`
if [ -z "$AUTOFS" ]; then
  t_echo 2 "        No automounter entry - PASSES CHECK "
  exit 1
else
  t_echo 0 "        System automounter enabled REPAIRING Now"
ed - /etc/rc2.d/S74autofs << EOEF
g/\/usr\/lib\/autofs\/automountd/s/\/usr\/lib\/autofs\/automountd/#\/usr\/lib\/autofs\/automountd/g
g/\/usr\/sbin\/automount/s/\/usr\/sbin\/automount/#\/usr\/sbin\/automount/
w
q
EOEF
 AUTOFS=`grep -s "automount" /etc/rc2.d/S74autofs |\
	grep -v "^#" | awk '{print $1}'`
 t_echo 0 "        Automounter = "
 t_echo 0 "        $AUTOFS "
fi

}


CheckAutofs() {

if [ -f /etc/rc2.d/S74autofs ]; then
  t_echo 2 "         File /etc/rc2.d/S74autofs exists..."
  AUTOFS=`grep -s "automount" /etc/rc2.d/S74autofs |\
	grep -v "^#" | awk '{print $1}'`
 

  if [ -z "${AUTOFS}" ]; then
  t_echo 2 "        No automounter configured - PASSES CHECK"
  else
  t_echo 0 "         Automounter = "
  t_echo 0 "        $AUTOFS      - FAILS CHECK "   
  fi
else
  t_echo 2 "         File /etc/rc2.d/S74autofs doesn't exist - PASSES CHECK "
exit 1
fi

}


action=$1
	case ${action} in
	-[Ii]*)
	Intro
	;;
	 -[Ff]*)
	FixAutofs
	;;
	-[Vv]*)
	CheckAutofs
	;;
	*)
        t_echo 1 "        ERROR:Invalid arg $action"
        t_echo 1 "        ERROR:Usage $MYNAME -[ivf] (I)ntro/(V)erify/(F)ix"
        t_echo 1 " "
	;;
	esac
#finis
