:
#
umask 022
# This tool suite was written by and is copyright by Brad Powell , Matt 
# Archibald, and Dan Farmer 1992, 1993, 1994, 1995, 1996, 1997, 1998 with input 
# from Casper Dik, and Alec Muffett
#
# The copyright holder disclaims all responsibility or liability with 
# respect to its usage or its effect upon hardware or computer 
# systems, and maintains copyright as set out in the "LICENSE" 
# document which accompanies distribution. 

# setup
TITANHOME=`pwd`
PATH=/usr/ucb:/bin:/usr/bin:/sbin:$TITANHOME/lib
MYNAME=`basename $0`

# suck in some lib functions (t_echo, etc.)
#
. misc_functions.sh

case "`uname -r`" in
5.[678]*) ;;
*)
        t_echo 1 "ERROR - This script is Only supported on Solaris 2.6 and newer " 1>&2
        exit 1;;
esac

# did things work out or not?
action=`./sanity_check $MYNAME $1`
if test $? -ne 0 ; then
        exit 1
        fi
 
 
Intro() {

cat << EOF
 This disables the L1-A or stop-A keyboard sequence by modifying
 /etc/default/kbd. The change will not take affect until after a reboot.
 The line added is :
 
 KEYBOARD_ABORT=disabled
 
 
EOF
}

Fix() {
if  [ -f /etc/default/kbd ] ; then
		t_echo 2 "        Disabling the abort sequence "

		ed - /etc/default/kbd <<- ENDED
		a
		KEYBOARD_ABORT=disabled
		.
		wq!
		ENDED

        t_echo 1 "	Modifcations to /etc/default/kbd complete"
fi

}

Verify() {
   grep "KEYBOARD_ABORT=disabled" /etc/default/kbd >/dev/null 2>&-
   if [ $? -eq 0 ]; then
    t_echo 1 "         Abort sequence disabled  - PASSES CHECK"
   else
    t_echo 1 "         Abort sequence enabled - FAILS CHECK"
    exit 1
   fi
 
}


action=$1
case ${action} in
-[Ii])
Intro
;;
-[Ff]*)
Fix 
;;
-[Vv]*)
Verify
;;
*)
        t_echo 0 "         ERROR:Invalid arg $action"
        t_echo 0 "         ERROR:Usage $MYNAME -[ivf] (I)ntro/(V)erify/(F)ix"
;;
esac
