:
#
# version 3.0 Sep 25 11:21:02 PDT 1998

umask 022
# This tool suite was written by and is copyrighted by Brad Powell, Matt 
# Archibald, and Dan Farmer 1992, 1993, 1994, 1995, 1996, 1997, 1998 with input 
# from Casper Dik, and Alec Muffett.
#
# The copyright holder disclaims all responsibility or liability with 
# respect to its usage or its effect upon hardware or computer 
# systems, and maintains copyright as set out in the "LICENSE" 
# document which accompanies distribution. 

# setup
TITANHOME=`pwd`
PATH=/usr/sbin:/usr/ucb:/bin:/usr/bin:/sbin:$TITANHOME/lib
MYNAME=`basename $0`

OS=`uname -r`

# did things work out or not?
action=`sanity_check $MYNAME $1`
if test $? -ne 0 ; then
        exit 1
        fi

#
# suck in some lib functions (t_echo, etc.)
#
. misc_functions.sh

Intro() {
cat << EOF
 This changes the privileged port definition to above port 2050
 thus making the NFS server port (2049) be a privileged Unix port
 This eliminates some of the port looping through rpcbind tricks and
 some of the other NFS access tricks

 The program modifies /etc/rc2.d/S69inet adding in the lines:

  ndd -set /dev/udp udp_smallest_nonpriv_port 2050
  ndd -set /dev/tcp tcp_smallest_nonpriv_port 2050
EOF

}

CheckPort() {
   t_echo 2 "        Verifying port settings using ndd "
   PRIVPORT=` ndd /dev/tcp tcp_smallest_nonpriv_port`
   t_echo 2 " privileged port definition is currently set to $PRIVPORT"
   if [ $PRIVPORT != 2050 ]; then
   t_echo 2 ""
   t_echo 0 "        You should run $MYNAME with the -F option (port=$PRIVPORT)"
    else
   t_echo 2 " "
   t_echo 2 "     privileged port definition is set above 2050  -  PASSES CHECK "
   t_echo 2 " "
   fi
 
   if [ -z "$PRIVPORT" ]; then
   t_echo 1 "No speficic port settings found - FAILS CHECK "
    else
   t_echo 2 " "
   exit 1
   fi
}

FixPort() {
 t_echo 2 " Setting privileged port above 2050..."
 
 if [ -f /etc/rc2.d/S69inet ]; then

  egrep '(tcp_smallest_nonpriv|udp_smallest_nonpriv)' /etc/rc2.d/S69inet >/dev/null 2>&-

  if [ $? -eq 0 ]; then
  t_echo 2 "privileged port setting ok - PASSES CHECK "
  else
  t_echo 0 " Adding in the ndd option to raise privileged ports to 2050"
  t_echo 2 "	Modifications: "
ed - /etc/rc2.d/S69inet << EOEF
a
	ndd -set /dev/udp udp_smallest_nonpriv_port 2050
	ndd -set /dev/tcp tcp_smallest_nonpriv_port 2050
.
w
q
EOEF
  t_echo 2 "Setting privileged port definitions to 2050 now..."
fi
 
	ndd -set /dev/udp udp_smallest_nonpriv_port 2050
	ndd -set /dev/tcp tcp_smallest_nonpriv_port 2050
  t_echo 2 "REPAIRED"
else

  t_echo 2 "No ndd definitions in /etc/rc2.d/S69inet found"
fi
 }
 
action=$1
	 case ${action} in
	-[Ii]*)
	Intro
	;;
	  -[Ff]*)
	 FixPort
	 ;;
	 -[Vv]*)
	 CheckPort
	 ;;
	 *)
         t_echo 1 "        ERROR: Invalid arg $action - Exiting"
         t_echo 1 "        ERROR:Usage disable-NFS.bind.sh -[ivf] (I)ntro/(V)erify/(F)ix"
	 exit 1
	 ;;
	 esac
