:
#
# version 3.0 Sep 25 11:21:02 PDT 1998
# version 3.0.1 Thu Nov  5 12:32:00 PST 1998 bpowell fixed up so that
# accounts less than 100 really get set to noshell 

umask 022
# This tool suite was written by and is copyrighted by Brad Powell, Matt 
# Archibald, and Dan Farmer 1992, 1993, 1994, 1995, 1996, 1997, 1998 with input 
# from Casper Dik, and Alec Muffett.
#
# The copyright holder disclaims all responsibility or liability with 
# respect to its usage or its effect upon hardware or computer 
# systems, and maintains copyright as set out in the "LICENSE" 
# document which accompanies distribution. 

# setup
TITANHOME=`pwd`
PATH=/usr/ucb:/bin:/usr/bin:/sbin:$TITANHOME/lib
MYNAME=`basename $0`

OS=`uname -r`

# did things work out or not?
action=`sanity_check $MYNAME $1`
if test $? -ne 0 ; then
        exit 1
        fi


#
# suck in some lib functions (t_echo, etc.)
#
. misc_functions.sh

Intro() {

cat << EOF
 
 Ensure login shell for "system" accounts are disabled
 these are accounts < 100 > 60000 by default but may
 include others.  A basic listing for SysV Unix is:

 bin, daemon, adm, lp, smtp, uucp, nuucp, listen, nobody, noaccess

 Note: "sys" account is left open since it starts accounting
 
EOF

}

CreateNoShell() {

if [ -f /sbin/noshell ]
    then
                t_echo 2 "        File /sbin/noshell already exists; not changing"
                else
  t_echo 0 "         Creating /sbin/noshell"
  t_echo 2 " "

cat << EOF > /sbin/noshell
:
trap "" 1  2  3  4  5  6 7 8 9 10 11 12 15 19

HOSTNAME=`uname -n`
USER=`id | awk '{print $1}'`
/bin/cat /dev/null |/usr/ucb/mail -s "Attempted access by ${USER} on host ${HOSTNAME}" root@${HOSTNAME} &
echo "Sorry"
wait
exit

EOF
		chmod 555 /sbin/noshell
		if [ $? -ne 0 ]
                then
                t_echo 1 " Problems creating /sbin/noshell; exiting "
                exit 1
             fi  
        fi

}

CheckUsers() {

#
# Get UID/Uname under UID 100 and over UID 60001
PLIST=`awk -F":" '($3 < 100) {print};($3 > 60000) {print}' /etc/passwd |\
				 egrep -v '(ftp\:|root\:|sys\:)' | awk -F":" '{print $1}'`
PCOUNT=`echo $PLIST | wc -w`
t_echo 2 " Checking $PCOUNT Users.... "
t_echo 2 " Checking that shell set to noshell for: "
t_echo 2 -n " "
t_echo 2 $PLIST

GCOUNT=0
BCOUNT=0

t_echo 2 " Verify shell status.... "
t_echo 2 " "
for USR in $PLIST
 do
  NOSHEL=`grep "^$USR\:" /etc/passwd | grep ":/sbin/noshell$"`
  USHEL=`grep "^$USR\:" /etc/passwd | awk -F":" '{print $7}'`
  if [ -z "$NOSHEL" ]; then
   t_echo 0 "         $USR shell = $USHEL - FAILS CHECK"
   BCOUNT=`expr $BCOUNT + 1`
  else
   t_echo 2 " $USR shell secure = $USHEL - SHELL SET CORRECTLY"
   GCOUNT=`expr $GCOUNT + 1`
  fi
done

t_echo 2 " "

  if [ $GCOUNT -lt $PCOUNT ]; then
 t_echo 2 " $BCOUNT Users Not Secured Out Of $PCOUNT"
  fi

  if [ $GCOUNT -eq $PCOUNT ]; then
 t_echo 2 "         All User Accounts PASS CHECK"
	exit 1
  fi
	

}

FixUsers() {

t_echo 0 " Setting shell to noshell for: "
#
# Get UID/Uname under UID 100 and over UID 60001
PLIST=`awk -F":" '($3 < 100) {print};($3 > 60000) {print}' /etc/passwd |\
				 egrep -v '(ftp|root)' | awk -F":" '{print $1}'`
t_echo 0 " "
t_echo 0 "$PLIST"
t_echo 0 " "

for USER in $PLIST
 do
if grep "^$USER" /etc/passwd 
then
 t_echo 0 "        $USER login not disabled. REPAIRING"
SHELL1=`grep "^$USER\:" /etc/passwd | awk -F":" '{print $7}'| awk -F"/" '{print $2}'`
SHELL2=`grep "^$USER\:" /etc/passwd | awk -F":" '{print $7}'| awk -F"/" '{print $3}'`
echo $SHELL1
echo $SHELL2
ed - /etc/passwd << EOEF
g/^$USER/s/$SHELL1/sbin/g
.
w
g/^$USER/s/$SHELL2/noshell/g
.
w
q
EOEF
 t_echo 2 "         $USER shell = noshell - PASSES CHECK"
else
        t_echo 2 "        $USER shell = noshell - FAILS CHECK"
fi

done

}


action=$1
	case ${action} in
	-[Ii]*)
	Intro
	;;
	 -[Ff]*)
	CreateNoShell
	FixUsers
	;;
	-[Vv]*)
	CheckUsers
	;;
	*)
 t_echo 1 "         ERROR:Invalid arg $action"
 t_echo 1 "         ERROR:Usage $MYNAME -[ivf] (I)ntro/(V)erify/(F)ix"
 t_echo 1 " "
	;;
	esac
# finis

