:
#
# version 3.0 Sep 25 11:21:02 PDT 1998

umask 022
# This tool suite was written by and is copyrighted by Brad Powell, Matt 
# Archibald, and Dan Farmer 1992, 1993, 1994, 1995, 1996, 1997, 1998 with input 
# from Casper Dik, and Alec Muffett.
#
# The copyright holder disclaims all responsibility or liability with
# respect to its usage or its effect upon hardware or computer
# systems, and maintains copyright as set out in the "LICENSE"
# document which accompanies distribution.

# setup
TITANHOME=`pwd`
PATH=/usr/ucb:/bin:/usr/bin:/sbin:$TITANHOME/lib
MYNAME=`basename $0`


# did things work out or not?
action=`sanity_check $MYNAME $1`
if test $? -ne 0 ; then
        exit 1
        fi
 
#
# suck in some lib functions (t_echo, etc.)
#
. misc_functions.sh

case "`uname -r`" in 
5.[45678]*) ;; 
*) 
 t_echo 1 " Only supported on Solaris 2.4 and newer"
        exit 1;; 
esac


Intro() {

cat << EOF

This changed the /etc/system file making the core dump size limited
to zero length. This prevents bad-guys forcing a core dump to examine
any information that might be stored in the core. Reference the old
bug where you could force a core with gcore of processes like rpc.pwauthd

EOF

}

Fix() {
        if [ -f /etc/system ] ; then
        t_echo 2 "   /etc/system exists "
        t_echo 2 "   saving a copy of the old /etc/system to /etc/system.ORIG2"
        /bin/cp /etc/system /etc/system.ORIG.$$
                if [ $? -ne 0 ]
                then
                        t_echo 1
                        t_echo 1 "Could not rename /etc/system; exiting"
                        exit 1
                fi
        fi
 
# if the file isn't there create it
 
        if [  ! -f /etc/system ] ; then
        t_echo 0 "   Creating /etc/system and limiting core files"
        /bin/cat << EOF2 > /etc/system
 
        * added to limit core files size
        set sys:coredumpsize = 0

EOF2
fi

# if the file is there append to it

if [  -f /etc/system ]; then
        t_echo 0 "   Changing /etc/system to limit core filesize"
        /bin/cat << EOF3 >> /etc/system

* added to limit core file size
set sys:coredumpsize = 0

EOF3

	t_echo 2 "   Core files have been disabled"
        else
        t_echo 0 "   Core dump size has not been set:  FAILS CHECK "
fi

/bin/chmod 644 /etc/system
}

Check() {

if [ -f /etc/system ] ; then
	grep "set sys:coredumpsize = 0" /etc/system >/dev/null 2>&-
	if [ $? -eq 0 ]; then
	t_echo 2 " Core dump size is already set to zero: PASSES CHECK"
	t_echo 2 "     "
	else
	t_echo 0 " Core dump size has not been set:  FAILS CHECK"
	fi
fi

}

action=$1
 
   case ${action} in
        -[Ii]*)
        Intro
        ;;
        -[Ff]*)
        Fix
        ;;
        -[Vv]*)
        Check
        ;;
        *)
        t_echo 1 "        ERROR:Invalid arg $action"
        t_echo 1 "        ERROR:Usage $0 -[ivf] (I)ntro/(V)erify/(F)ix"
        exit 1
	;;
        esac


