:
#
# version 3.0 Sep 25 11:21:02 PDT 1998
# version 3.0.1 Thu Nov  5 13:06:19 PST 1998 bpowell: new check to see
# if you already had a line, so we don't keep adding one in if you
# run -F multiple times

umask 022
# This tool suite was written by and is copyrighted by Brad Powell, Matt 
# Archibald, and Dan Farmer 1992, 1993, 1994, 1995, 1996, 1997, 1998 with input 
# from Casper Dik, and Alec Muffett.
#
# The copyright holder disclaims all responsibility or liability with 
# respect to its usage or its effect upon hardware or computer 
# systems, and maintains copyright as set out in the "LICENSE" 
# document which accompanies distribution. 

# setup
TITANHOME=`pwd`
PATH=/usr/ucb:/bin:/usr/bin:/sbin:$TITANHOME/lib
MYNAME=`basename $0`

# did things work out or not?
action=`sanity_check $MYNAME $1`
if test $? -ne 0 ; then
        exit 1
        fi
 

#
# suck in some lib functions (t_echo, etc.)
#
. misc_functions.sh

Intro() {

cat << EOF
 This disables ip_respond_to_echo_broadcast so that specific ping crashes
 don't work. The program modifies /etc/rc2.d/S69inet

	ndd -set /dev/ip ip_respond_to_echo_broadcast 0 

EOF

}

FixIPBroadcast() {
if [ -f /etc/rc2.d/S??inet ]; then
 grep "ip_respond_to_echo_broadcast" /etc/rc2.d/S??inet >/dev/null 2>&-
   if [ $? -ne 0 ]; then

	t_echo 0 "        Adding the new ndd command"

ed - /etc/rc2.d/S??inet <<- !
a
ndd -set /dev/ip ip_respond_to_echo_broadcast 0
.
w
q
!

   t_echo 2 "	Modifications to /etc/rc2.d/S??inet complete"

	else t_echo 0 " Error - ip_respond_to_echo_broadcast is already set"
fi
fi
	t_echo 2 "	"
}

CheckIPBroadcast() {
 grep "ip_respond_to_echo_broadcast" /etc/rc2.d/S??inet >/dev/null 2>&-
   if [ $? -eq 0 ]; then
    t_echo 2 "         Ping echo response denied - PASSED CHECK"
#    t_echo 2 " "
#    grep "ip_respond_to_echo_broadcast" /etc/rc2.d/S??inet
    t_echo 2 " "
   else
    t_echo 0 "         Ping echo response allowed - FAILED CHECK"
    t_echo 0 "         Run $0 with -[Ff] to fix... "
    t_echo 0 " "
    exit 1
   fi
}

action=$1
case ${action} in
-[Ii])
Intro
;;
-[Ff]*)
FixIPBroadcast
;;
-[Vv]*)
CheckIPBroadcast
;;
*)
        t_echo 1 "         ERROR:Invalid arg $action"
        t_echo 1 "         ERROR:Usage $MYNAME -[ivf] (I)ntro/(V)erify/(F)ix"
        t_echo 1 " "
;;
esac
