:
#
# version 3.0 Sep 25 11:21:02 PDT 1998

umask 022
# This tool suite was written by and is copyrighted by Brad Powell, Matt 
# Archibald, and Dan Farmer 1992, 1993, 1994, 1995, 1996, 1997, 1998 with input 
# from Casper Dik, and Alec Muffett.
#
# The copyright holder disclaims all responsibility or liability with 
# respect to its usage or its effect upon hardware or computer 
# systems, and maintains copyright as set out in the "LICENSE" 
# document which accompanies distribution. 

# setup
TITANHOME=`pwd`
PATH=/usr/ucb:/bin:/usr/bin:/sbin:$TITANHOME/lib
MYNAME=`basename $0`

OS=`uname -r`

# did things work out or not?
action=`sanity_check $MYNAME $1`
if test $? -ne 0 ; then
        exit 1
        fi

#
# suck in some lib functions (t_echo, etc.)
#
. misc_functions.sh

Intro() {

cat << EOF

 This disables source routing and IP forwarding at boot time.
 The program modifies /etc/rc2.d/S69inet overruling
 the default settings listed in S69inet, with the following lines:

	 ndd -set /dev/ip ip_forward_src_routed 0
	 ndd -set /dev/ip ip_forwarding 0
	 ndd -set /dev/ip ip_forward_directed_broadcasts 0
	 ndd -set /dev/ip ip_ignore_redirect 1
	 ndd -set /dev/ip ip_strict_dst_multihoming 1

 We also touch /etc/notrouter in the Fix mode

Note: On FW-1 systems on rare occasions you might want to leave ip_forward on.
      However in production enviornments the source routing should always be off.
 

EOF
}

CheckForward() {
PARAMS="ip_forwarding ip_forward_src_routed ip_forward_directed_broadcasts ip_ignore_redirect ip_strict_dst_multihoming"
if [  -f /etc/rc2.d/S69inet ]; then

for PARAM in $PARAMS
 do
t_echo 2 " Checking $PARAM..."

ONE=`grep "${PARAM}*1" /etc/rc2.d/S69inet`
ZERO=`grep "${PARAM}*0" /etc/rc2.d/S69inet`

case ${PARAM} in
  ip_forwarding|ip_forward_src_routed|ip_forward_directed_broadcasts)
	if [ "$ZERO" ]; then
	 t_echo 2 "${PARAM} enabled - FAILS CHECK"
	else
	 t_echo 2 "${PARAM} disabled  - PASSES CHECK"
	fi
	;;
  ip_ignore_redirect| ip_strict_dst_multihoming)
	if [ "$ONE" ]; then
	 t_echo 2 "${PARAM} disabled - FAILS CHECK"
	else
	 t_echo 2 "${PARAM} enabled  - PASSES CHECK"
	fi
	;;
	*)
	t_echo 2 "Found a value I didn't expect"
	;;
esac
done
	else

 t_echo 1 "         No /etc/rc2.d/S69inet file found - ERROR"
fi

}

CheckRouter() {
   if [ -f /etc/notrouter ]; then
 t_echo 2 "         System configured as 'notrouter' - PASSES CHECK"
        else
 t_echo 2 "         /etc/notrouter does not exist - FAILS CHECK"
        fi
 
}


FixIPComms() {
t_echo 0 " Disabling ip_forward, source_route, forward_broadcast "
t_echo 0 " and setting strict_multihoming in /etc/rc2.d/S69inet"
t_echo 2  "  "

if [ -f /etc/rc2.d/S69inet ]; then
 egrep '(src_routed 0|ignore_redirect 1|broadcasts 0|multihoming 1)' /etc/rc2.d/S69inet >/dev/null 2>&-
 if [ $? -eq 0 ]; then
	t_echo 2 "Settings look okay - PASSES CHECK"
 else
ed - /etc/rc2.d/S69inet << EOEF
a
	ndd -set /dev/ip ip_forwarding 0
	ndd -set /dev/ip ip_forward_src_routed 0
        ndd -set /dev/ip ip_forward_directed_broadcasts 0
	ndd -set /dev/ip ip_ignore_redirect 1
        ndd -set /dev/ip ip_strict_dst_multihoming 1

.
w
q
EOEF
fi

 else
 t_echo 2 "No titan file found - FAILS CHECK"
fi

}

FixRouter() {
   if [ -f /etc/notrouter ]; then
 t_echo 2 "         System configured as 'notrouter' - PASSES CHECK"
        else
        touch /etc/notrouter
 t_echo 0 "         Created /etc/notrouter - Routing now disabled"
        fi

}

action=$1
	case ${action} in
	-[Ii]*)
	Intro
	;;
	 -[Ff]*)
	CheckForward
	FixIPComms
	FixRouter
	;;
	-[Vv]*)
	CheckForward
	CheckRouter
	;;
	*)
 t_echo 1 "         ERROR:Invalid arg $action"
 t_echo 1 "         ERROR:Usage $MYNAME -[ivf] (I)ntro/(V)erify/(F)ix"
 t_echo 1 " "
	;;
	esac
