:
#
# version 3.0 Sep 25 11:21:02 PDT 1998
# rev 1.1 Tue Oct 13 10:49:04 PDT 1998

umask 022
# This tool suite was written by and is copyrighted by Brad Powell, Matt 
# Archibald, and Dan Farmer 1992, 1993, 1994, 1995, 1996, 1997, 1998 with input 
# from Casper Dik, and Alec Muffett.
#
# The copyright holder disclaims all responsibility or liability with 
# respect to its usage or its effect upon hardware or computer 
# systems, and maintains copyright as set out in the "LICENSE" 
# document which accompanies distribution. 

# setup
TITANHOME=`pwd`
PATH=/usr/bin:/bin:/usr/ucb:/sbin:$TITANHOME/lib
MYNAME=`basename $0`
CONTENT=/var/sadm/install/contents

OS=`uname -r`
HOST=`uname -n`

# did things work out or not?
action=`sanity_check $MYNAME $1`
if test $? -ne 0 ; then
        exit 1
        fi

#
# suck in some lib functions (t_echo, etc.)
#
. misc_functions.sh

Intro() {

cat << EOF

 This utility will modify permissions in /etc, /usr, /sbin
 and /opt to something closer to a secure Unix operating
 system configuration. 
 Changes some file permissions so that becoming "bin" or whatever
 doesn't mean you can plant a trojan for root to step on.
 Most of this is redundant to the fix-modes that you will run
 later but this helps a little up front....

EOF

}

FixOwner() {
	DIRLIST1="/usr /sbin"
	DIRLIST2="/usr /sbin /etc /opt"
	for DIR in $DIRLIST1
	do
	t_echo 0 " Changing $DIR ownership"
	find $DIR -fstype ufs -mount -user bin -print | xargs chown root 2>&-
	done

	for DIR2 in $DIRLIST2
	do
	t_echo 0 " Changing $DIR2 group permissions"
	find $DIR2 -fstype ufs -mount -group bin -perm -020 -print | xargs chmod g-w 2>&-
	done

}

CheckOwner() {

DIRLIST1="/usr /sbin"
DIRLIST2="/usr /sbin /etc /opt"
	for DIR in $DIRLIST1
	do
	t_echo 2 " Checking $DIR file ownership"
	find $DIR -fstype ufs -mount -user bin -print > ${TITANHOME}/tmp/$DIR.plist.$HOST
	OWN=`wc -l  ${TITANHOME}/tmp/$DIR.plist.$HOST | awk '{print $1}'` 2>&-
	t_echo 0 " Found $OWN files in $DIR that should be root owned"
	rm  ${TITANHOME}/tmp/$DIR.plist.$HOST
	done

	for DIR2 in $DIRLIST2
        do
	t_echo 2 " Checking $DIR2 group permissions"
	find $DIR2  -fstype ufs -mount -group bin -perm 020 -print > ${TITANHOME}/tmp/$DIR2.glist.$HOST 2>&-
	OWN=`wc -l  ${TITANHOME}/tmp/$DIR2.glist.$HOST | awk '{print $1}'` 2>&-
	t_echo 0 " Found $OWN files in $DIR2 that should be set group g-w"
	rm  ${TITANHOME}/tmp/$DIR2.glist.$HOST
	done

}

action=$1
	case ${action} in
	-[Ii]*)
	Intro
	;;
	 -[Ff]*)
	FixOwner
	;;
	-[Vv]*)
	CheckOwner
	;;
	*)
        t_echo 1 "         ERROR:Invalid arg $action"
        t_echo 1 "         ERROR:Usage $MYNAME -[ivf] (I)ntro/(V)erify/(F)ix"
        t_echo 1 " "
	;;
	esac

