:
#
# version 3.0 Sep 25 11:21:02 PDT 1998

umask 022
#
# $Id: fix-modes,v 2.10 1998/01/02 09:18:35 casper Exp casper $
#
# Origionally from Casper Dik (casper@fwi.uva.nl)
#
# This tool suite was written by and is copyrighted by Brad Powell, Matt 
# Archibald, and Dan Farmer 1992, 1993, 1994, 1995, 1996, 1997, 1998 with input 
# from Casper Dik, and Alec Muffett.
#
# The copyright holder disclaims all responsibility or liability with 
# respect to its usage or its effect upon hardware or computer 
# systems, and maintains copyright as set out in the "LICENSE" 
# document which accompanies distribution. 


# setup
TITANHOME=`pwd`
PATH=/usr/ucb:/bin:/usr/bin:/sbin:$TITANHOME/lib:`dirname $0`
MYNAME=`basename $0`

#
# suck in some lib functions (t_echo, etc.)
#
. misc_functions.sh

OS=`uname -r`
ARCH=`uname -p`
PWD=`/usr/bin/pwd`
case ${ARCH} in
  *spar*) MODES="modes.sparc";export MODES;;
  *86*) MODES="modes.x86";export MODES;;
  *) t_echo 1 "No valid OS for fix-modes"
     exit 1
;;
esac

Intro() {
 
cat << EOFM
   
 This utility will modify file and directory permissions in most of the 
 Operating System areas. 

 Most of this is redundant to the file-own that you ran
 earlier but thanks to Casper Dik this version is far more generic...

EOFM

}

FixModes() {

# Only works for 5.2-5.6, check the modes program for each new revision
# and adjust script accordingly.
# Probably works for 2.7 and later.

case "`uname -r`" in
5.[23456]*) ;;
	*)  
	t_echo 1 " Only supported on Solaris 2.2 thru 2.6"
	exit 1;;
esac

 t_echo 2 " Checking for ${TITANHOME}/lib/${MODES}..."
 ${MODES} > /tmp/changes$$ || {
 t_echo 1 " Could not find ${MODES} aborting fix-modes" 1>&2
	rm -f /tmp/changes$$ /tmp/contents
	exit 1
}
if [ -s /tmp/changes$$ ]; then
 t_echo 2 " Using data from ${TITANHOME}/lib/${MODES}..."
    find /var/sadm -xdev \( -perm -020 -o -perm -002 \) -print >> /tmp/changes$$
        t_echo 0 " Removing group and world write privileges..."
    xargs chmod og-w < /tmp/changes$$
    touch /var/adm/messages
    chmod og-w /var/adm/messages
    set -e

    # Always save old contents file.  The very first one becomes increasingly
    # out of date.  Previously, we saved the very first contents file.

    t_echo 2 " Saving a new contents file in /var/sadm/install"
    rm -f /var/sadm/install/contents.org.Z
    mv /var/sadm/install/contents /var/sadm/install/contents.org
    compress /var/sadm/install/contents.org
    mv /tmp/contents /var/sadm/install/contents
    chmod 644 /var/sadm/install/contents
else
    rm -f /tmp/contents
fi
# Our install scripts created these with owner root.
if [ ! -f /var/lp/logs/lpNet ]
then
    touch /var/lp/logs/lpNet /var/lp/logs/lpsched
fi
chown lp /var/lp/logs/lpNet /var/lp/logs/lpsched

 t_echo 2 " Cleaning up our /tmp/changes$$ file..."

rm -f /tmp/changes$$

}


VrfyModes() {

# Only works for 5.2-5.6, check the modes program for each new revision
# and adjust script accordingly.
# Probably works for 2.7 and later.

case "`uname -r`" in
5.[23456]*) ;;
*)  
 t_echo 1 " Only supported on Solaris 2.2 thru 2.6"
	exit 1;;
esac

 t_echo 2 " Listing all files we are willing to modify permissions for...."

 t_echo 2 " Checking for ${TITANHOME}/lib/${MODES}..."
${TITANHOME}/lib/${MODES} > /tmp/changes$$ || {
 t_echo 1 " Could not find ${MODES} aborting fix-modes"
	rm -f /tmp/changes$$ /tmp/contents
	exit 1
}
if [ -s /tmp/changes$$ ]; then
    t_echo 2 " Using data from ${TITANHOME}/lib/${MODES}..."
    t_echo 0 " Need to remove group and world write privileges on files."
    find /var/sadm -xdev \( -perm -020 -o -perm -002 \) -print >> /tmp/changes$$
    more /tmp/changes$$

    # Always save old contents file.  The very first one becomes increasingly
    # out of date.  Previously, we saved the very first contents file.
fi
#
# Our install scripts created these with owner root.

    t_echo 2 " Cleaning up out /tmp/changes$$ file...."
    rm -f /tmp/changes$$
    t_echo 2 " Run with -[Ff] to set modes on the files you reviewed.."

}

#
# Main Section Here
#

action=$1

case ${action} in
 -[Ii]*)
 Intro
 ;;
 -[Ff]*)
  FixModes
;;
-[Vv]*)
  VrfyModes
;;
  *)
  t_echo 1 
  t_echo 0 "       ERROR:Usage $MYNAME -[ivf] (I)ntro/(V)erify/(F)ix "
  t_echo 1 
  t_echo 1 
  t_echo 1 
;;
esac
