:
#
# version 3.0 Sep 25 11:21:02 PDT 1998

umask 022
#		  
# basically a titan wrapper for Casper Dik's stack protection
# This tool suite was written by and is copyrighted by Brad Powell, Matt 
# Archibald, and Dan Farmer 1992, 1993, 1994, 1995, 1996, 1997, 1998 with input 
# from Casper Dik, and Alec Muffett.
#
# The copyright holder disclaims all responsibility or liability with 
# respect to its usage or its effect upon hardware or computer 
# systems, and maintains copyright as set out in the "LICENSE" 
# document which accompanies distribution. 

# setup
TITANHOME=`pwd`
PATH=/usr/ucb:/bin:/usr/bin:/sbin:$TITANHOME/lib
MYNAME=`basename $0`
OS=`uname -r`

# did things work out or not?
action=`sanity_check $MYNAME $1`
if test $? -ne 0 ; then
        exit 1
        fi

#
# suck in some lib functions (t_echo, etc.)
#
. misc_functions.sh

case "`uname -r`" in
5.[5]*) ;;
5.[6]*)
        t_echo 1 "ERROR - Please run the fix-stack-2.6.sh instead"
        exit 1;; 
*)
	t_echo 1 "ERROR - This script is Only known to work on Solaris 2.5.[0-5]"
        exit 1;; 

esac

Intro() {

cat << EOF

 Creates /etc/init.d/protect_stack and links in /etc/rc2.d/S07protect_stack
 this has the effect of forcing all user zero-fill-on-demand pages are marked
 rw- instead of rwx. The maximum (user settable) protection remains rwx, so the
 effect of this change can be undone with mprotect(). The initial stack segment
 is also marked rw- instead of rwx [ due to limitation in what you can do 
 with adb, the maximum protection of the initial stack segment is also rw- ]

EOF

}

CheckStack() {

  if [ -f /etc/init.d/protect_stack ]; then
   t_echo 2 "         File /etc/init.d/protect_stack already exists - PASSES CHECK"
   t_echo 2 " "
   else
   t_echo 0 "         No /etc/init.d/protect_stack exists - FAILS CHECK"
   t_echo 2 "         Run with -[Ff] option to Fix"
   t_echo 2 " "
   exit 1
  fi

}

FixStack() {

if [ -f /etc/init.d/protect_stack ]; then
   t_echo 2 "         File /etc/init.d/protect_stack already exists - PASSES CHECK"
   exit 0
  else

 if [ -f ../src/stubs/protect_stack ]; then
      /bin/cp ../src/stubs/protect_stack /etc/init.d/protect_stack
     if [ $? -ne 0 ]; then
        t_echo 1
        t_echo 1 "         Could not create /etc/init.d/protect_stack - ERROR"
        exit 1
     fi

     /usr/ucb/chown root.staff /etc/init.d/protect_stack
     /bin/chmod 750 /etc/init.d/protect_stack
     /usr/bin/ln -s /etc/init.d/protect_stack /etc/rc2.d/S07protect_stack
     t_echo 0 " /etc/init.d/protect_stack and link /etc/rc2.d/S07protect_stack created"

 else
       t_echo 1 " "
       t_echo 1 "         Could not open ../src/stubs/protect_stack - ERROR"
       exit 1
 fi
fi
 

} # End FixStack

# Main

action=$1
case ${action} in
 -[Ii]*)
 Intro
 ;;
 -[Ff]*)
 FixStack
 ;;
 -[Vv]*)
 CheckStack
 ;;
 *)
        t_echo 1 "         ERROR:Invalid arg $action"
        t_echo 1 "         ERROR:Usage $MYNAME -[ivf] (I)ntro/(V)erify/(F)ix"
        t_echo 1 " "
;;
esac
