:
#
# version 3.0 Sep 25 11:21:02 PDT 1998

umask 022
# This tool suite was written by and is copyrighted by Brad Powell, Matt 
# Archibald, and Dan Farmer 1992, 1993, 1994, 1995, 1996, 1997, 1998 with input 
# from Casper Dik, and Alec Muffett.
#
# The copyright holder disclaims all responsibility or liability with 
# respect to its usage or its effect upon hardware or computer 
# systems, and maintains copyright as set out in the "LICENSE" 
# document which accompanies distribution. 

# setup
TITANHOME=`pwd`
PATH=/usr/ucb:/bin:/usr/bin:/sbin:$TITANHOME/lib
MYNAME=`basename $0`

# did things work out or not?
action=`sanity_check $MYNAME $1`
if test $? -ne 0 ; then
        exit 1
        fi
 
#
# suck in some lib functions (t_echo, etc.)
#
. misc_functions.sh


case "`uname -r`" in
5.[678]*) ;;
*)
        t_echo 1 "ERROR - This script is Only supported on Solaris 2.6 and newer, please use one of the other scripts for your OS "
        exit 1;;
esac


Intro() {

cat << EOF

 adds the following entry into /etc/system to force all users 
 zero-fill-on-demand pages are marked rw- instead of rwx on the
 stack

    * Don't allow executing code on the stack
    set noexec_user_stack = 1

    * And log it when it happens.
    set noexec_user_stack_log = 1

EOF

}

FixStack() {

        if [ -f /etc/system ]; then
         t_echo 2 " Saving /etc/system to /etc/system.ORIG"
         /bin/cp /etc/system /etc/system.ORIG.$$
          if [ $? -ne 0 ]; then
           t_echo 1 "     ERROR:Could not rename /etc/system; exiting"
           exit 1
	  else
           t_echo 0 " Changing /etc/system for stack protecting"
           echo "* Don't allow executing code on the stack" >>/etc/system
           echo "set noexec_user_stack = 1" >>/etc/system
           echo "* And log it when it happens." >>/etc/system
           echo "set noexec_user_stack_log = 1" >>/etc/system
           chmod 644 /etc/system
           t_echo 2 "Done ... "
          fi
	else
         touch /etc/system
           t_echo 0 "         Creating /etc/system to protect the stack"
 	   echo "* Don't allow executing code on the stack" >>/etc/system   
           echo "set noexec_user_stack = 1" >>/etc/system
           echo "* And log it when it happens." >>/etc/system
           echo "set noexec_user_stack_log = 1" >>/etc/system
         chmod 644 /etc/system
        fi

}

CheckStack() {

        if [ -f /etc/system ]; then
         grep "set noexec_user_stack = 1" /etc/system | grep -v "#" >/dev/null 2>&-
         if [ $? -eq 0 ]; then
         t_echo 2 " Stack seems to already protected  - PASSES CHECK"
	 exit 1
         else
         t_echo 0 "        Stack Protection not currently set - Run $MYNAME -F "
         fi
        else
         t_echo 1 "        No /etc/system file - No verification possible"
         exit 1
        fi

}

action=$1

   case ${action} in
	-[Ii]*)
	Intro
	;;
	-[Ff]*)
	FixStack
	;;
	-[Vv]*)
	CheckStack	
	;;
	*)
        t_echo 1 "        ERROR:Invalid arg $action"
        t_echo 1 "        ERROR:Usage $0 -[ivf] (I)ntro/(V)erify/(F)ix"
	exit 1;;
	esac

#finis
