:
#
# version 3.0 Sep 25 11:21:02 PDT 1998

umask 022
# This tool suite was written by and is copyrighted by Brad Powell, Matt 
# Archibald, and Dan Farmer 1992, 1993, 1994, 1995, 1996, 1997, 1998 with input 
# from Casper Dik, and Alec Muffett.
#
# The copyright holder disclaims all responsibility or liability with 
# respect to its usage or its effect upon hardware or computer 
# systems, and maintains copyright as set out in the "LICENSE" 
# document which accompanies distribution. 

# setup
TITANHOME=`pwd`
PATH=/usr/ucb:/bin:/usr/bin:/sbin:$TITANHOME/lib
MYNAME=`basename $0`
OS=`uname -r`

# did things work out or not?
action=`sanity_check $MYNAME $1`
if test $? -ne 0 ; then
        exit 1
        fi


#
# suck in some lib functions (t_echo, etc.)
#
. misc_functions.sh

Intro () {

cat << EOF

  Script to start keyserv with the "-d" option so that the defauls "nobody"
  key is not allowed. see "man keyserv" for more information.

EOF

}

Fix() {

if [ -f /etc/rc2.d/S71rpc ]; then
	cp /etc/rc2.d/S71rpc /etc/opt/S71rpc.ORIG
	 grep -i "/usr/sbin/keyserv -d" /etc/rc2.d/S*rpc
	if [ $? -ne 0 ]; then
 	t_echo 0 "        In $FILE keyserv is running without the -d flag ; REPAIRING"
		ed - /etc/rc2.d/S??rpc <<- !
		g/\    \       \       \/usr\/sbin\/keyserv/s/\/usr\/sbin\/keyserv/\/usr\/sbin\/keyserv\ -d/g
		.
		w
		q
		!
	fi
fi

}

Check() {

if [ -f /etc/rc2.d/S??rpc ]; then
      for FILE in `ls /etc/rc*.d/S??rpc`
       do
	grep -i "/usr/sbin/keyserv -d" /etc/rc2.d/S*rpc
	if [ $? -ne 0 ]; then
 t_echo 0 "        In $FILE keyserv ; user nobody enabled - FAILS CHECK"
	else
 t_echo 2 "         In $FILE keyserv user nobody disallowed - PASSES CHECK"
	fi
      done
fi

}

action=$1
	case ${action} in
	-[Ii]*)
	Intro
	;;
	 -[Ff]*)
	Fix
	;;
	-[Vv]*)
	Check
	;;
	*)
 t_echo 1 "        ERROR:Invalid arg $action"
 t_echo 1 "        ERROR:Usage $MYNAME -[ivf] (I)ntro/(V)erify/(F)ix"
 t_echo 1 " "
	;;
	esac

