:
#
# version 3.0 Sep 25 11:21:02 PDT 1998

umask 022
# This tool suite was written by and is copyrighted by Brad Powell, Matt 
# Archibald, and Dan Farmer 1992, 1993, 1994, 1995, 1996, 1997, 1998 with input 
# from Casper Dik, and Alec Muffett.
#
# The copyright holder disclaims all responsibility or liability with 
# respect to its usage or its effect upon hardware or computer 
# systems, and maintains copyright as set out in the "LICENSE" 
# document which accompanies distribution. 

# setup
TITANHOME=`pwd`
PATH=/usr/ucb:/bin:/usr/bin:/sbin:$TITANHOME/lib
MYNAME=`basename $0`
DATE=`/bin/date +%m%d%y%H%M`

#
# suck in some lib functions (t_echo, etc.)
#
. misc_functions.sh

# did things work out or not?
action=`sanity_check $MYNAME $1`
if test $? -ne 0 ; then
        exit 1
        fi

Intro() {

cat << EOF

 
Changes the in.inetd startup configuration to use the "-t" flag
in /etc/rc2.d/S72inetsvc. 

 From the inetd man page:

	-t 	Instructs inetd to trace the incoming  connections
               	for all of its TCP services.  It does this by log-
               	ging the client's IP address and TCP port  number,
               	along with the name of the service, using the sys-
               	log(3) facility.

EOF

}

Fix() {

 if [ -f /etc/rc2.d/S72inetsvc ]; then
        grep -i "^\/usr\/sbin\/inetd\ \-s\ \-t$" /etc/rc2.d/S72inetsvc
        if [ $? -eq 0 ]; then
	t_echo 2 " /etc/rc2.d/S72inetsvc is already running -t  - Not Changing"
	exit 1
	else
        if [ -f /etc/rc2.d/S72inetsvc ]; then
        t_echo 2 " Saving /etc/rc2.d/S72inetsvc to ${TITANHOME}/tmp/S72inetsvc.ORIG.${DATE}"
        cp /etc/rc2.d/S72inetsvc ${TITANHOME}/tmp/S72inetsvc.ORIG.${DATE}
	if [ $? -ne 0 ]; then
           t_echo 1 "     Could not save file to ${TITANHOME}/tmp/S72inetsvc.ORIG.${DATE} - ERROR"
           exit 1
	else
	t_echo 0     " Changing inetd startup default "
	ed /etc/rc2.d/S72inetsvc <<- EDEND
	g/^\/usr\/sbin\/inetd/s/\/usr\/sbin\/inetd\ \-s/\/usr\/sbin\/inetd\ \-s\ \-t/
	.
        w
	q
	EDEND
           t_echo 2 " inetd startup in /etc/rc2.d/S72inetsvc changed ... "
          fi
        fi
	fi
 fi

}

Check() {

        if [ -f /etc/rc2.d/S72inetsvc ]; then
	grep -i "^\/usr\/sbin\/inetd\ \-s$" /etc/rc2.d/S72inetsvc
	if [ $? -eq 0 ]; then
 	 t_echo 0 "       /etc/rc2.d/S72inetsvc - has the system default . - FAILS CHECK"
	 exit 1
         else
	fix=`grep "^\/usr\/sbin\/inetd\ \-s\ \-t" /etc/rc2.d/S72inetsvc`
	if [ "${fix}" = "/usr/sbin/inetd -s -t" ]; then
         t_echo 1 "  /etc/rc2.d/S72inetsvc : -  PASSES CHECK" 
	fi
	fi
         fi
}

action=$1

   case ${action} in
	-[Ii]*)
	Intro
	;;
	-[Ff]*)
	Fix
	;;
	-[Vv]*)
	Check
	;;
	*)
        t_echo 1 "        ERROR:Invalid arg $action"
        t_echo 1 "        ERROR:Usage $0 -[ivf] (I)ntro/(V)erify/(F)ix"
	exit 1;;
	esac

