:
#
# version 3.0 Sep 25 11:21:02 PDT 1998

umask 022
# This tool suite was written by and is copyrighted by Brad Powell, Matt 
# Archibald, and Dan Farmer 1992, 1993, 1994, 1995, 1996, 1997, 1998 with input 
# from Casper Dik, and Alec Muffett.
#
# The copyright holder disclaims all responsibility or liability with 
# respect to its usage or its effect upon hardware or computer 
# systems, and maintains copyright as set out in the "LICENSE" 
# document which accompanies distribution. 

# setup
TITANHOME=`pwd`
PATH=/usr/ucb:/bin:/usr/bin:/sbin:$TITANHOME/lib
MYNAME=`basename $0`
OS=`uname -r`

# did things work out or not?
action=`sanity_check $MYNAME $1`
if test $? -ne 0 ; then
        exit 1
        fi

#
# suck in some lib functions (t_echo, etc.)
#
. misc_functions.sh

Intro() {

cat << EOF

 This program creates /var/adm/loginlog so that failed login
 attempts will be captured and stored for review

EOF

}

FixLoginLog() {

	if [ -f /var/adm/loginlog ]; then
  t_echo 2 " File /var/adm/loginlog already exists; exiting"
		exit 1
	else 
	 /usr/bin/touch /var/adm/loginlog
	 /usr/bin/chmod 0640 /var/adm/loginlog
	 /usr/ucb/chown root.sys /var/adm/loginlog
  t_echo 0 " File /var/adm/loginlog created sucessfully"
	fi

}

CheckLoginLog() {

	if [ -f /var/adm/loginlog ]; then
  t_echo 2 " File /var/adm/loginlog already exists - PASSES CHECK"
	 exit 1
	else 
  t_echo 0 "        No /var/adm/loginlog file - FAILS CHECK"
	fi
}

action=$1
	case ${action} in
	-[Ii]*)
	Intro
	;;
	 -[Ff]*)
	FixLoginLog
	;;
	-[Vv]*)
	CheckLoginLog
	;;
	*)
 t_echo 1 "        ERROR:Invalid arg $action"
 t_echo 1 "        ERROR:Usage $MYNAME -[ivf] (I)ntro/(V)erify/(F)ix"
 t_echo 1 " "
	;;
	esac
