:
#
# version 3.0 Sep 25 11:21:02 PDT 1998

umask 022
# This tool suite was written by and is copyrighted by Brad Powell, Matt 
# Archibald, and Dan Farmer 1992, 1993, 1994, 1995, 1996, 1997, 1998 with input 
# from Casper Dik, and Alec Muffett.
#
# The copyright holder disclaims all responsibility or liability with 
# respect to its usage or its effect upon hardware or computer 
# systems, and maintains copyright as set out in the "LICENSE" 
# document which accompanies distribution. 

# setup
TITANHOME=`pwd`
PATH=/usr/ucb:/bin:/usr/bin:/sbin:$TITANHOME/lib
MYNAME=`basename $0`

OS=`uname -r`

# did things work out or not?
action=`sanity_check $MYNAME $1`
if test $? -ne 0 ; then
        exit 1
        fi


#
# suck in some lib functions (t_echo, etc.)
#
. misc_functions.sh

Intro () {

cat << EOF

 Enables NFS port monitoring by adding to /etc/system:

	set nfssrv:nfs_portmon = 1
	set nfs:nfs_portmon = 1


EOF

}

FixNfsmon() {

        if [ -f /etc/system ]; then
         t_echo 2 " Saving /etc/system to /etc/system.ORIG"
         /bin/cp /etc/system /etc/system.ORIG
          if [ $? -ne 0 ]; then
           t_echo 1 "     ERROR - Could not rename /etc/system; exiting"
           exit 1
	  else
           t_echo 0 " Changing /etc/system enabling port monitoring"
#           echo "set nfs:nfs_portmon = 1" >>/etc/system
           echo "set nfssrv:nfs_portmon = 1" >>/etc/system
           chmod 644 /etc/system
           t_echo 2 "NFS server port monitoring enabled  ... "
          fi
	else
         touch /etc/system
         t_echo 0 " Creating /etc/system enabling port monitoring"
         echo "* added to enable port monitoring" >>/etc/system
#         echo "set nfs:nfs_portmon = 1" >>/etc/system
         echo "set nfssrv:nfs_portmon = 1" >>/etc/system
         chmod 644 /etc/system
        fi

}

CheckNfsmon() {

        if [ -f /etc/system ]; then
         grep "nfs_portmon" /etc/system | grep -v "#" >/dev/null 2>&-
         if [ $? -eq 0 ]; then
            t_echo 2 "        NFS port monitor enabled - PASSES CHECK"
	    exit 1
         else
            t_echo 0 "        NFS port monitor disabled - FAILS CHECK"
         fi
        else
           t_echo 1 "         ERROR No /etc/system file - cannot verify"
           exit 1
        fi

}

action=$1

   case ${action} in
	-[Ii]*)
	Intro
	;;
	-[Ff]*)
	FixNfsmon
	;;
	-[Vv]*)
	CheckNfsmon	
	;;
	*)
        t_echo 1 "        ERROR:Invalid arg $action"
        t_echo 1 "        ERROR:Usage $MYNAME -[ivf] (I)ntro/(V)erify/(F)ix"
	exit 1;;
	esac

#finis
