:
#
# version 3.0 Sep 25 11:21:02 PDT 1998

umask 022
# This tool suite was written by and is copyrighted by Brad Powell, Matt 
# Archibald, and Dan Farmer 1992, 1993, 1994, 1995, 1996, 1997, 1998 with input 
# from Casper Dik, and Alec Muffett.
#
# The copyright holder disclaims all responsibility or liability with 
# respect to its usage or its effect upon hardware or computer 
# systems, and maintains copyright as set out in the "LICENSE" 
# document which accompanies distribution. 

# setup
TITANHOME=`pwd`
PATH=/usr/ucb:/bin:/usr/bin:/sbin:$TITANHOME/lib
MYNAME=`basename $0`

OS=`uname -r`
#
# Names for original files
#
ORIG="orig"
# ORIG="asetoriginal"

# did things work out or not?
action=`sanity_check $MYNAME $1`
if test $? -ne 0 ; then
        exit 1
        fi

#
# suck in some lib functions (t_echo, etc.)
#
. misc_functions.sh

Intro() {

cat << EOF


 This script configures in.routed to run in quiet mode. 
 In order to do this we:

   1) Move /usr/sbin/in.routed to /usr/sbin/in.routed.$ORIG
   2) Build a wrapper starting routed -q (quiet mode).

 You can modify this prior to running with -[Ff] to
 in.routed.asetorignal for ASET compatibility by editing
 the internal variable ORIG in this shell script.

EOF
}


CheckRouted() {

 if [ -f /usr/sbin/in.routed.$ORIG ]; then
	grep "\-q" /usr/sbin/in.routed >/dev/null 2>&-
       if [ $? -eq 0 ]; then
        t_echo 2 "   "
        t_echo 2 " The route daemon is configured to not advertise routes - PASSES CHECK"
	exit 1
       else
        t_echo 1 "        Not the in.routed I expected - FAILS CHECK..."
       fi
 else       
        t_echo 0 "   "
        t_echo 0 "         The route daemon advertises routes - FAILS CHECK"
 fi

} # End CheckRouted


FixRouted() {

 grep "\-q" /usr/sbin/in.routed >/dev/null 2>&-
  if [ $? -eq 0 ]
   then
   t_echo 1
   t_echo 1 "ERROR - in.routed already a script - NO REPLACE"
   else
   t_echo 1 "Replacing in.routed with wrapper"
   if [ -x /usr/sbin/in.routed ]; then
   /bin/mv /usr/sbin/in.routed /usr/sbin/in.routed.ORIG
   else
   t_echo 1 "No /usr/sbin/in.routed to fix - ERROR"
   exit 1
   fi
  fi
 
echo "#! /bin/sh" > /usr/sbin/in.routed
if [ $? -ne 0 ]
        then
        t_echo 1
        t_echo 1 "     ERROR - Could not create new ${ROUTED} script."
        exit 1
fi
echo "/usr/sbin/in.routed.$ORIG -q" >> /usr/sbin/in.routed
/bin/chmod 0755 /usr/sbin/in.routed
if [ $? -ne 0 ]
        then
        t_echo 1
        t_echo 1 "       ERROR - Could not chmod new ${ROUTED} script."
        exit 1
        fi
 
t_echo 2
t_echo 2 " Renamed in.routed to in.routed.$ORIG"
t_echo 2 " Installed new in.routed script."

} # End FixRouted


action=$1
case ${action} in
	-[Ii]*)
	Intro
	;;
	 -[Ff]*)
 	 FixRouted
	;;
	-[Vv]*)
	 CheckRouted
	;;
	*)
        t_echo 1 "        ERROR:Invalid arg $action"
        t_echo 1 "        ERROR:Usage $MYNAME -[ivf] (I)ntro/(V)erify/(F)ix"
        t_echo 1 " "
;;
esac
