:
#
# version 3.0 Sep 25 11:21:02 PDT 1998
# Revision 1.2 changed by:brad powell Mon Sep 28 11:46:19 PDT 1998

umask 022
# This tool suite was written by and is copyrighted by Brad Powell, Matt 
# Archibald, and Dan Farmer 1992, 1993, 1994, 1995, 1996, 1997, 1998 with input 
# from Casper Dik, and Alec Muffett.
#
# The copyright holder disclaims all responsibility or liability with 
# respect to its usage or its effect upon hardware or computer 
# systems, and maintains copyright as set out in the "LICENSE" 
# document which accompanies distribution. 

# setup
TITANHOME=`pwd`
PATH=/usr/ucb:/bin:/usr/bin:/sbin:$TITANHOME/lib
MYNAME=`basename $0`

# OS sanity check

OS=`uname -r`

# did things work out or not?
action=`sanity_check $MYNAME $1`
if test $? -ne 0 ; then
        exit 1
        fi

#
# suck in some lib functions (t_echo, etc.)
#
. misc_functions.sh

Intro() {

cat << EOF
 Adds the following flag to /etc/mail/sendmail.cf.
 This flag stops nosey persons from connecting to port
 25 and using expn and vrfy to gather information.

     # privacy flags
     # O PrivacyOptions=authwarnings,goaway
     Opgoaway
     # O PrivacyOptions=noexpn, novrfy, authwarnings
     O LogLevel=5

	Additionally checks for /sbin/smrsh and fixes sendmail.cf if it finds it
	if you don't have smrsh get it! supplement to the CERT advisory 
        CA-93:16.sendmail.vulnerability

EOF
}

CheckGoaway() {
if [ -f /etc/mail/sendmail.cf ]; then
 
 if [ -f /etc/mail/sendmail.cf.titan2 ]; then
 
  t_echo 2 "       File /etc/mail/sendmail.cf.titan2 exists - Checking content"
  grep "Opgoaway" /etc/mail/sendmail.cf >/dev/null

  if [ $? -ne 0 ]; then
   t_echo 0 "      A config file is in place but doesn't have Opgoaway set - FAILS CHECK"
   exit 1
  else
   t_echo 2 "      The Opgoaway option is in place - PASSES CHECK"
  fi
 
 else
   t_echo 1 "      No sendmail.cf.titan2 exists - FAILS CHECK"
   t_echo 1 "      Run with -[Ff] option to fix."

 fi
 
else
 t_echo 1 ""
 t_echo 1 "/etc/mail/sendmail.cf doesn't exist; exiting"
 t_echo 1 "Could not save current semdmail.cf or could not find it"
 exit 1
fi

t_echo 2 " Checking for smrsh "
    if [ -f /sbin/smrsh -a -f /etc/mail/sendmail.cf ] ; then
      grep "smrsh" /etc/mail/sendmail.cf >/dev/null
        if [ $? -ne 0 ]; then
          t_echo 0 "      smrsh isn't set in /etc/mail/sendmail.cf  - FAILS CHECK"
          exit 1
        else
             t_echo 2 "      Smrsh is listed in /etc/mail/sendmail.cf  - PASSES CHECK"
        fi
    else
            t_echo 0 " smrsh not found in /sbin -  FAILS CHECK"
    fi
}

FixGoaway() {
 
# Here is where we add in the option
 
if [ -f /etc/mail/sendmail.cf ]; then
 
 /bin/cp /etc/mail/sendmail.cf /etc/mail/sendmail.cf.titan2 >/dev/null
 
 if [ $? -eq 0 ]; then
 t_echo 2 "        Adding in the Opgoaway line "

ed - /etc/mail/sendmail.cf <<- !
/Options
a
         
.
a
# Privacy Flags
.
a
Opgoaway
.
a
# Logging auth notices
.
a
O LogLevel=5
.
w
q
!

 
 t_echo 2 "     "   
 t_echo 2 "        Sendmail Option added "
 t_echo 2 "     "   
else
 t_echo 1 "        Could not backup /etc/mail/sendmail.cf - ERROR"
 exit 1
 fi
fi

t_echo 0 " Changing the sendmail shell to smrsh"
if [ -f /sbin/smrsh -a -f /etc/mail/sendmail.cf ]; then
	t_echo 2 " adding in smrsh to /etc/mail/sendmail.cf"

ed - /etc/mail/sendmail.cf <<- !
g/P=\/bin\/sh,/s//P=\/sbin\/smrsh,/g
w
q
!

else
        t_echo 1 " /sbin/smrsh does not exist - ERROR"
        exit 1
fi
 
} # End FixGoaway

action=$1
	case $action in
	-[Ii]*)
	Intro
	;;
	-[Ff]*)
	 FixGoaway
	;;
	-[Vv]*)
	 CheckGoaway
	;;
	*)
        t_echo 1 " ERROR:Invalid arg $action"
        t_echo 1 " ERROR:Usage $MYNAME -[ivf] (I)ntro/(V)erify/(F)ix"
        t_echo 1 " "
	;;
esac

