:
#
# version 3.0 Sep 25 11:21:02 PDT 1998

umask 022
# This tool suite was written by and is copyrighted by Brad Powell, Matt 
# Archibald, and Dan Farmer 1992, 1993, 1994, 1995, 1996, 1997, 1998 with input 
# from Casper Dik, and Alec Muffett.
#
# The copyright holder disclaims all responsibility or liability with 
# respect to its usage or its effect upon hardware or computer 
# systems, and maintains copyright as set out in the "LICENSE" 
# document which accompanies distribution. 

# setup
TITANHOME=`pwd`
PATH=/usr/ucb:/bin:/usr/bin:/sbin:$TITANHOME/lib
MYNAME=`basename $0`

OS=`uname -r`

# did things work out or not?
action=`sanity_check $MYNAME $1`
if test $? -ne 0 ; then
        exit 1
        fi
 
#
# suck in some lib functions (t_echo, etc.)
#
. misc_functions.sh

Intro() {
cat << EOF

 This changes the sendmail banner to not report what mail 
 version is running. It changes your login banner from something 
 like This:
 
	Sendmail SMI-8.6/SMI-SVR4 ready at Fri, 2 May 1997

		TO

     	Sendmail Server Ready


EOF
}

CheckBanner() {

if [ -f /etc/mail/sendmail.cf ]; then

 if [ -f /etc/mail/sendmail.cf.titan1 ]; then

  t_echo 2 " File /etc/mail/sendmail.cf.titan1 exists - Checking content"
  grep "Sendmail Server Ready" /etc/mail/sendmail.cf >/dev/null

  if [ $? -ne 0 ]; then
   t_echo 0 "         A config file is in place but the banner still give out info - ERROR"
   exit 1
  else
   t_echo 2 "         Sendmail Server Ready message in place - PASSES CHECK"
  fi

 else
   t_echo 0 "         No /etc/mail/sendmail.cf exists - FAILS CHECK"
 fi

else
 t_echo 1 ""
 t_echo 1 "         No /etc/mail/sendmail.cf exists"
 t_echo 1 "         Could not save current semdmail.cf or could not find it"
 exit 1
fi

}

FixBanner() {

# Here is where we add in the option 

if [ -f /etc/mail/sendmail.cf ]; then

 /bin/cp /etc/mail/sendmail.cf /etc/mail/sendmail.cf.titan1 >/dev/null

 if [ $? -eq 0 ]; then
 t_echo 2 " Changing the Sendmail Ready line "

ed - /etc/mail/sendmail.cf <<- !
g/De\$j Sendmail \$v\/\$V ready at \$b/s/De\$j Sendmail \$v\/\$V ready at \$b/De Sendmail Server Ready/
w
q
!

 t_echo 2 "     "
 t_echo 2 " Sendmail login message changed"
 t_echo 2 "     "
 else
 t_echo 2 " Could not backup /etc/mail/sendmail.cf - ERROR"
 exit 1
 fi
fi

} # End FixBanner


action=$1
case $action in
	-[Ii]*)
	Intro
	;;
	 -[Ff]*)
	 FixBanner
	;;
	-[Vv]*)
	 CheckBanner
	;;
	*)
        t_echo 2 "         ERROR:Invalid arg $action"
        t_echo 2 "         ERROR:Usage $MYNAME -[ivf] (I)ntro/(V)erify/(F)ix"
        t_echo 2 " "
;;
esac
