:
#
# version 3.0 Sep 25 11:21:02 PDT 1998

umask 022
# This tool suite was written by and is copyrighted by Brad Powell, Matt 
# Archibald, and Dan Farmer 1992, 1993, 1994, 1995, 1996, 1997, 1998 with input 
# from Casper Dik, and Alec Muffett.
#
# The copyright holder disclaims all responsibility or liability with 
# respect to its usage or its effect upon hardware or computer 
# systems, and maintains copyright as set out in the "LICENSE" 
# document which accompanies distribution. 

# setup
TITANHOME=`pwd`
PATH=/usr/ucb:/bin:/usr/bin:/sbin:$TITANHOME/lib
MYNAME=`basename $0`

#
# suck in some lib functions (t_echo, etc.)
#
. misc_functions.sh

case "`uname -r`" in
5.[6]*) ;;
*)
        t_echo 1 "ERROR - This script is Only supported on Solaris 2.6 and newer, please use one of the other scripts for your OS "
        exit 1;;
esac


# did things work out or not?
action=`sanity_check $MYNAME $1`
if test $? -ne 0 ; then
        exit 1
        fi


Intro() {

cat << EOF

 
Simply moves aside all the snmpdx daemons start up files. Snmpdx give out more
information than you really want it to. Who needs a port scanner if snmpdx is running?


EOF

}

Fix() {

        if [ -f /etc/rc2.d/S76snmpdx ]; then
	t_echo 0     " Killing snmpdx daemon "
	/etc/rc2.d/S76snmpdx stop
         t_echo 2 " Saving and disabling /etc/rc2.d/S76snmpdx to /etc/rc2.d-S76snmpdx.ORIG"
         /bin/mv /etc/rc2.d/S76snmpdx /etc/rc2.d-S76snmpdx.ORIG.$$
         /bin/mv /etc/rc3.d/S76snmpdx /etc/rc3.d-S76snmpdx.ORIG.$$
         t_echo 2 " Saving /etc/init.d/init.snmpdx to /etc/init.d-init.snmpdx.ORIG"
         /bin/mv /etc/init.d/init.snmpdx /etc/init.d-init.snmpdx.ORIG.$$
	chmod 0100 /etc/rc2.d-S76snmpdx.ORIG$$ 
	chmod 0100 /etc/rc3.d-S76snmpdx.ORIG$$ 
	chmod 0100 /etc/init.d-init.snmpdx.ORIG$$
          if [ $? -ne 0 ]; then
           t_echo 1 "     ERROR:Could not rename /etc/rc2.d-S76snmpdx ; exiting"
           exit 1
	  else
           t_echo 2 "Done ... "
          fi
        fi

}

Check() {

        if [ -f /etc/init.d/init.snmpdx ]; then
         t_echo 0 "   Snmpdx daemon is enabled: FAILS CHECK"
	 exit 1
         else
         t_echo 2 "  Snmpdx doesn't start at boot time: PASSES CHECK" 
         fi

}

action=$1

   case ${action} in
	-[Ii]*)
	Intro
	;;
	-[Ff]*)
	Fix
	;;
	-[Vv]*)
	Check
	;;
	*)
        t_echo 1 "        ERROR:Invalid arg $action"
        t_echo 1 "        ERROR:Usage $0 -[ivf] (I)ntro/(V)erify/(F)ix"
	exit 1;;
	esac

