:
#
# version 3.0 Sep 25 11:21:02 PDT 1998

umask 022
# This tool suite was written by and is copyrighted by Brad Powell, Matt 
# Archibald, and Dan Farmer 1992, 1993, 1994, 1995, 1996, 1997, 1998 with input 
# from Casper Dik, and Alec Muffett.
#
# The copyright holder disclaims all responsibility or liability with 
# respect to its usage or its effect upon hardware or computer 
# systems, and maintains copyright as set out in the "LICENSE" 
# document which accompanies distribution. 

# setup
TITANHOME=`pwd`
PATH=/usr/ucb:/bin:/usr/bin:/sbin:$TITANHOME/lib
MYNAME=`basename $0`

OS=`uname -r`

# did things work out or not?
action=`sanity_check $MYNAME $1`
if test $? -ne 0 ; then
        exit 1
        fi

#
# suck in some lib functions (t_echo, etc.)
#
. misc_functions.sh

Intro() {

cat << EOF

 This program modifies /etc/syslog.conf so that console auth
  notice messages also get sent to the logfiles

EOF
}

#
# Make changes to syslog here.....
#
FixSyslog() {

 if [ -f /etc/syslog.conf ]; then
    t_echo 2 " File /etc/syslog.conf exists saving and continuing..."
    /bin/cp /etc/syslog.conf /etc/syslog.conf.ORIG
   else
    t_echo 1 "       ERROR - File /etc/syslog.conf does not exist "
    exit 1
 fi


 if [ `awk '{print $1}' /etc/syslog.conf | grep "^#auth.notice"` ]; then
  t_echo 0 " Syslog auth notice messages disabled.. Fixing now..."
ed - /etc/syslog.conf << EOEF
g/#auth.notice/s/#auth.notice/auth.notice/
.
w
q
EOEF
  else
  t_echo 2 "       Syslog is auditing auth notices - PASSES CHECK"
  exit 1
fi

# send a KILL HUP signal to the syslog daemon so the change gets noticed

t_echo 0 " Telling Syslog to reset daemon and cache changes..."

PID=`cat /etc/syslog.pid`
kill -HUP $PID

}

#
# Verify syslog config here.....
#
VrfySyslog() {

 if [ -f /etc/syslog.conf ]; then
   t_echo 2 " File /etc/syslog.conf exists checking contents...."
  else
   t_echo 1 "       ERROR - File /etc/syslog.conf does not exist exiting"
   exit 1
 fi

 if [ `awk '{print $1}' /etc/syslog.conf | grep "^#auth.notice"` ]; then
  t_echo 0 "        Syslog auth notice messages disabled - FAILS CHECK"
 else
  t_echo 2 "        Syslog is auditing auth notices - PASSES CHECK"
   exit 1
 fi
 
}

#
# Main section here

action=$1
case $action in
	-[Ii]*)
	Intro
	;;
	 -[Ff]*)
	  FixSyslog
	 ;;
	 -[Vv]*)
	  VrfySyslog
	 ;;
	 *)
 	 t_echo 1 " "
	 t_echo 1 "        ERROR:Invalid arg $action"
	 t_echo 1 "        ERROR:Usage $MYNAME -[ivf] (I)ntro/(V)erify/(F)ix"
 	 t_echo 1 " "
 	;;
esac
