:
#
# version 3.0 Sep 25 11:21:02 PDT 1998

umask 022
# This tool suite was written by and is copyrighted by Brad Powell, Matt 
# Archibald, and Dan Farmer 1992, 1993, 1994, 1995, 1996, 1997, 1998 with input 
# from Casper Dik, and Alec Muffett.
#
# The copyright holder disclaims all responsibility or liability with 
# respect to its usage or its effect upon hardware or computer 
# systems, and maintains copyright as set out in the "LICENSE" 
# document which accompanies distribution. 

#setup  dont change this unless you want to do some work on the script
IFS=:

TITANHOME=`pwd`
PATH=/usr/ucb:/bin:/usr/bin:/sbin:$TITANHOME/lib
MYNAME=`basename $0`

OS=`uname -r`

# did things work out or not?
action=`sanity_check $MYNAME $1`
if test $? -ne 0 ; then
        exit 1
        fi
 
#
# suck in some lib functions (t_echo, etc.)
#
. misc_functions.sh

Intro() {

cat << EOFM

 This programs adds umask 022 to startup files for users shell
 in /etc and /etc/skel as appropriate and UMASK=022 in /etc/default/login


EOFM
}

FixUmask() {

for FILE in  /etc/.login  /etc/profile /etc/skel/local.cshrc /etc/skel/local.login /etc/skel/local.profile

 do
 if [ -f ${FILE} ]; then
t_echo 0 " Adding umask 022 to ${FILE}...."

ed - ${FILE} << EOEF
1
/^.*/s/^.*/umask 022/
w
q
EOEF

 else
t_echo 1 " File ${FILE} does not exist - passing"
 fi

done

for FILE in /etc/default/login 

 do
 if [ -f ${FILE} ]; then
t_echo 0 " Adding UMASK=022 to ${FILE}...."

ed - ${FILE} << EOEF
1
/^.*/s/^.*/UMASK=022/
w
q
EOEF
 
 else
t_echo 2 " File ${FILE} does not exist - passing"
 fi
 
done

t_echo 2

}

VrfyUmask() {

t_echo 2 " Checking for umask 022 in : "
for FILE in  /etc/.login  /etc/default/login /etc/profile /etc/skel/local.cshrc /etc/skel/local.login /etc/skel/local.profile
 do
t_echo 2 " ${FILE}"
done
t_echo 2

for FILE in /etc/.login /etc/.login /etc/profile /etc/skel/local.cshrc /etc/skel/local.login /etc/skel/local.profile
 do
 if [ -f ${FILE} ]; then
 if [ `grep "umask 022" ${FILE}` ]; then
  t_echo 2 "       Umask value 022 in ${FILE} - PASSES CHECK"
 else
  t_echo 0 "       Umask value other than 022 in ${FILE} - FAILS CHECK"
 fi
 else
t_echo 1 "       File ${FILE} does not exist - skipping"
 fi

done
t_echo 2

for FILE in /etc/default/login
 do
 if [ -f ${FILE} ]; then 
 if [ `grep "UMASK=022" ${FILE}` ]; then
 t_echo 2 "       UMASK value 022 in ${FILE} - PASSES CHECK"
 else
  t_echo 0 "       UMASK value other than 022 in ${FILE} - FAILS CHECK"
 fi
 else
t_echo 2 "       File ${FILE} does not exist - skipping"
 fi
done

}

#
# Main section here
#
action=$1
case $action in
	-[Ii]*)
	Intro
	;;
	 -[Ff]*)
	 FixUmask
	;;
	-[Vv]*)
	  VrfyUmask
	;;
	*)
        t_echo 1 "       ERROR:Invalid arg $action"
        t_echo 1 "       ERROR:Usage $MYNAME -[ivf] (I)ntro/(V)erify/(F)ix"
        t_echo 1 " "
;;
esac
