:
#
# version 3.0 Sep 25 11:21:02 PDT 1998

umask 022
# This tool suite was written by and is copyrighted by Brad Powell, Matt 
# Archibald, and Dan Farmer 1992, 1993, 1994, 1995, 1996, 1997, 1998 with input 
# from Casper Dik, and Alec Muffett.
#
# The copyright holder disclaims all responsibility or liability with 
# respect to its usage or its effect upon hardware or computer 
# systems, and maintains copyright as set out in the "LICENSE" 
# document which accompanies distribution. 

# setup
TITANHOME=`pwd`
PATH=/usr/ucb:/bin:/usr/bin:/sbin:$TITANHOME/lib
MYNAME=`basename $0`


OS=`uname -r`

# did things work out or not?
action=`sanity_check $MYNAME $1`
if test $? -ne 0 ; then
        exit 1
        fi

#
# suck in some lib functions (t_echo, etc.)
#
. misc_functions.sh

Intro() {
cat << EOF

This program simply moves aside /etc/vold.conf and /usr/sbin/vold so that
vold does not start at system boot.

EOF

}

CheckVold() {

if [ -f /etc/rc2.d/S92volmgt -a -x /usr/sbin/vold ] ; then
   t_echo 0 " "
   t_echo 0 " File /etc/rc2.d/S92volmgt and /usr/sbin/vold exists - FAILS CHECK "
   t_echo 2 " "
   t_echo 2 "      Run with -[Ff] option to fix"
   exit 1
else
   t_echo 2 "      Could not find /etc/rc2.d/S92volmgt - PASSES CHECK "
   t_echo 2 "      This would imply that you don't need to run with -[Ff] option to fix"
  exit 1
fi 
}

FixVold() {

if [ -f /etc/rc2.d/S92volmgt -a -x /usr/sbin/vold ] ; then
   t_echo 0 " " 
   t_echo 0 " Moving aside /etc/vold.conf to /etc/vold.conf.ORIG "
		/bin/mv /etc/vold.conf /etc/vold.conf.ORIG
   t_echo 2 " "
   t_echo 2 " Now moving aside /usr/sbin/vold to /usr/sbin/vold.ORIG "
		/bin/mv /usr/sbin/vold /usr/sbin/vold.ORIG
		/usr/bin/chmod 100 /usr/sbin/vold.ORIG
else
  t_echo 1 "/etc/rc2.d/S92volmgt doesn't seem to exist; exiting"
  exit 1
fi
}

action=$1
case $action in
 -[Ff]*)
FixVold
;;
 -[Vv]*)
CheckVold
;;
 -[Ii]*)
Intro
;;

*)
        t_echo 1 "        ERROR:Invalid arg $action"
        t_echo 1 "        ERROR:Usage $MYNAME -[ivf] (I)ntro/(V)erify/(F)ix"
        t_echo 1 " "
;;
esac

 
#finis
