:
#
# version 3.0 Sep 25 11:21:02 PDT 1998

umask 022
# This tool suite was written by and is copyrighted by Brad Powell, Matt 
# Archibald, and Dan Farmer 1992, 1993, 1994, 1995, 1996, 1997, 1998 with input 
# from Casper Dik, and Alec Muffett.
#
# The copyright holder disclaims all responsibility or liability with 
# respect to its usage or its effect upon hardware or computer 
# systems, and maintains copyright as set out in the "LICENSE" 
# document which accompanies distribution. 

# setup
TITANHOME=`pwd`
PATH=/usr/ucb:/bin:/usr/bin:/sbin:$TITANHOME/lib
MYNAME=`basename $0`

#
# suck in some lib functions (t_echo, etc.)
#
. misc_functions.sh

# did things work out or not?

action=`sanity_check $MYNAME $1`
if test $? -ne 0 ; then
        exit 1
        fi
 

Intro() {

cat << EOF

 This script simply runs " ncheck -F ufs -s |wc -l" to get a listing of all suid
 programs on local UFS file systems. It requires you to modifying the  "known_suid"
 variable to reflect the current output of your system. We then compare the current
 number of suid binaries against the "known_suid". If the current number is higher
 then the know number this would indicate a new suid binary has appeared, and should
 be investigated.

 This is typically a CHECK ONLY utility since it requires a system administrator
 to check if the change was valid or not.

EOF
}

Check() {

	if [ -x /usr/sbin/ncheck ]; then
	current_suid=`/usr/sbin/ncheck -F ufs -s |wc -l`
	known_suid=276
	if [ ${known_suid} != ${current_suid} ]; then
                 t_echo 2 "         Current listing of SUID files does not match the known listing - FAILS CHECK"
                 t_echo 2 "   "
		 exit 1
		else
		t_echo 2 " Current SUID listing equals known listing - PASSES CHECK"
	fi
	fi
}

action=$1
case ${action} in
 -[Ii]*)
 Intro
 ;;
 -[Ff]*)
 Check
 ;;
 -[Vv]*)
 Check
 ;;
 *)
        t_echo 1 "         ERROR:Invalid arg $action"
        t_echo 1 "         ERROR:Usage $MYNAME -[ivf] (I)ntro/(V)erify/(F)ix"
        t_echo 1 " "
;;
esac
